/*
 * Copyright (c) 2020 STMicroelectronics
 *
 * SPDX-License-Identifier: Apache-2.0
 */

/**
 * @file SoC configuration macros for the STM32WL family processors.
 *
 * Based on reference manual:
 *   STM32WLxx advanced ARM ® -based 32-bit MCUs
 *
 * Chapter 2.6: Memory organization
 */


#ifndef _STM32WL_SOC_H_
#define _STM32WL_SOC_H_

#ifndef _ASMLANGUAGE

#include <stm32wlxx.h>

/* Add generated devicetree information and STM32 helper macros */
#include <st_stm32_dt.h>

#endif /* !_ASMLANGUAGE */

#endif /* _STM32WL_SOC_H_ */
